/*
 *
 * this file is part of the "cdmon" project
 * Copyright (C) 2004 by Jean Philippe GUILLEMIN <jp.guillemin@free.fr>
 * license: This software is under GPL license
 * rev: 0.41
 */
 
#include "cdmon.h"

 
/***************** MAIN ********************/

int main(int argc, char *argv[]) {
	int i, status, nbdev;
	if (argc > 1) if (! (strncmp (argv[1], "-h", 2))) {usage(); exit(1);};
	char *evt, *configfile;
	evt = malloc(SHORT_STRING);
	strncpy(evt, "FAMChanged", SHORT_STRING);

 	configfile = malloc(MEDIUM_STRING);	
	
	strncpy(configfile, __CONFPATH, MEDIUM_STRING);
	strcat(configfile, "/");		
	strcat(configfile, __CONFFILE);	
	
	int c;
	FILE *file;
	char 	*sep, 
				*buffer, 
				*line, 
				*value;
	line = malloc(LONG_STRING); 
	buffer = malloc(MEDIUM_STRING); 
	sep = malloc(SHORT_STRING); 
	value = malloc(SHORT_STRING);
	
	i=1; 
	c = 0;	
	
	if((file=fopen(configfile, "rb")) == 0) {
		fprintf (stderr,"Error opening file %s !\n",configfile);
		exit(EXIT_FAILURE);
	}
	
	while (fgets (line, LONG_STRING, file) !=NULL) {
		if (strstr (line, "[") !=0) continue;
		if (strstr (line, "#") !=0) continue;
		if (strstr (line, "/dev/") != 0) {
			i++;
		}	
	}
	nbdev = i;
	char *dev[nbdev];
	i=1;
	rewind(file); 
	while (fgets (line, LONG_STRING, file) !=NULL) {
		if (strstr (line, "[") !=0) continue;
		if (strstr (line, "#") !=0) continue;
		memset(value, 0, SHORT_STRING);
		memset(buffer, 0, SHORT_STRING);
		c = sscanf (line, "%s %s %s", buffer, sep, value); 
		//fprintf(stderr, "procdev=%s\n", value); // debug
		if (strstr (line, "/dev/") != 0) {
			c = sscanf (line, "%s %s %s", buffer, sep, value); 
			 /* Allocate storage for devices names */
			dev[i] = malloc(SHORT_STRING);		
			memset(dev[i], 0, SHORT_STRING);
			strncat(dev[i], buffer, SHORT_STRING);
			//fprintf(stderr, "dev[%i]=%s\n", i, dev[i]); // debug
			i++;
		}	
	}
	fclose (file);
	//fprintf(stderr, "famdetect_start\n"); // debug
	status = famdetect(nbdev, dev, evt);
exit(1);   
}


/***************** usage ********************/
int usage(void) {
	fprintf(stdout,"\ncdmon v0.41 : CD device monitor (jp.guillemin@free.fr)\n");
	fprintf(stdout, "Usage : cdmon&\n");
	fprintf(stdout, "-> devices mappings are defined in the cdmon.cf file\n");
	return(EXIT_SUCCESS);
} // end usage
