
/*
 * File: cdmon.h
 *
 * this file is part of the "cdmon" project
 * Copyright (C) 2004 by Jean Philippe GUILLEMIN <jp.guillemin@free.fr>
 * license: This software is under GPL license
 * rev: 0.41
 */

#include <fam.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/select.h>
#include <sysexits.h>
#include <wait.h>

//#include <getopt.h>
//#include <stdarg.h>

#ifndef __CONFPATH
#define __CONFPATH "/etc/cdmon"
#endif

#ifndef __CONFFILE
#define __CONFFILE "cdmon.conf"
#endif

#ifndef __ICONPATH
#define __ICONPATH "/usr/share/cdmon"
#endif

#define SHORT_STRING 64
#define MEDIUM_STRING 128
#define BIG_STRING 256
#define LONG_STRING 1024
#define EXTRALONG_STRING 4096

/**********************/
/*      PROTOTYPES    */
/**********************/


/* famdetect connects to famd with a list of info-files to look for modifications or any event supported by SGI-FAM*/
int famdetect(int nbdev, char * device[], char *event);

/* small utility function to get the name of an event from famd event_id_code */
const char *get_event_name_from_id(int code);

/* usage function */
int usage(void);


/* this function is the frontend dockapp. It's forked from famdetect() */
int dockapp( char *sysdev, int argc, char * argv[]);

/* parse the config file for a given parameter and returns both char value and unsigned integer value */
int parse_from_config
		(u_int32_t 
		*uint_value, 
		char *char_value1, 
		char *char_value2, 
		char *filename, 
		char *param );

/* parse /etc/fstab file for a given device and returns the mount point */
int parse_mountpoint
		(char *char_value, 
		char *filename, 
		char *param);

/* parse an info-file in /sys or /proc file to get model information 
about the device */
int get_media
		(char *char_value, 
		char *sysdev);
