/*
 *
 * this file is part of the "cdmon" project
 * Copyright (C) 2004 by Jean Philippe GUILLEMIN <jp.guillemin@free.fr>
 * license: This software is under GPL license
 * rev: 0.41
 */

#include "cdmon.h"
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <gtk/gtk.h>

GtkWidget *create_main_dockapp_icon_window
		(GtkWidget *mw,
		unsigned int s,
		int margc,
		char *margv[]);

void callback
		(GtkWidget *event_box, 
		GdkEventButton *event,
		gpointer *data[]);

int dockapp( char *procdev, int argc, char * argv[]) {
	int output; 
	GtkWidget *mainwin;
	GtkWidget *mainbox;
	GtkWidget *pixmap;
	GdkBitmap *mask;
	GtkWidget *pixmap_widget;	
	GtkWidget *box;
	GtkWidget *labelbox;
	GtkWidget *table;
	GtkWidget *label;	
	
	u_int32_t uint_param_value;
	
	char		*dev,
				*devstring,
				*mountpoint,
				*configfile,
				*parameter, 
				*char_param_value1, 
				*char_param_value2, 
				*command, 
				*imagefile,
				*mount_cmd,
				*fontsize,
				*model;

	configfile = malloc(MEDIUM_STRING);	
	dev = malloc(MEDIUM_STRING);
	devstring = malloc(BIG_STRING);
	mountpoint = malloc(MEDIUM_STRING);
	parameter = malloc(MEDIUM_STRING);
	char_param_value1 = malloc(BIG_STRING); 
	char_param_value2 = malloc(BIG_STRING); 
	command = malloc(MEDIUM_STRING);
	imagefile = malloc(BIG_STRING);
	mount_cmd = malloc(MEDIUM_STRING);
	fontsize = malloc(MEDIUM_STRING);	
	model = malloc(MEDIUM_STRING);
	char	*data[3];



// Here we parse command line args and configfile
		strncpy(configfile, __CONFPATH, MEDIUM_STRING);	
		strcat(configfile, "/");
		strcat(configfile, __CONFFILE);	

	//fprintf(stderr, "configfile : %s\n", configfile);

	strncpy (parameter, procdev, MEDIUM_STRING);
	if (parse_from_config(&uint_param_value, char_param_value1, char_param_value2, configfile, parameter) == 0){
		strncpy(dev, char_param_value1, MEDIUM_STRING);
		strncpy(imagefile, __ICONPATH, BIG_STRING);
		strcat(imagefile, "/");
		strcat(imagefile, char_param_value2);
	}
	if (get_media(char_param_value1, parameter) == 0){
		strncpy(model, char_param_value1, MEDIUM_STRING);
	}
	//fprintf(stderr, "model : %s\n", model); //debug
	
	strncpy (parameter, "command", MEDIUM_STRING);
	if (parse_from_config(&uint_param_value, char_param_value1, char_param_value2, configfile, parameter) == 0){
		strncpy(command, char_param_value1, MEDIUM_STRING);
	}
	
	if (parse_mountpoint(char_param_value1, "/etc/fstab", dev) == 0){
		strncpy(mountpoint, char_param_value1, MEDIUM_STRING);
	}	
	
	gtk_init(&argc, &argv);
	
	mainwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_realize(mainwin);
	
	mainbox = create_main_dockapp_icon_window(mainwin, 54, argc, argv);
	
	table = gtk_table_new(4,4, TRUE);
	
	box = gtk_event_box_new ();
	labelbox = gtk_hbox_new (FALSE, 0);
	
	memset(mount_cmd, 0, MEDIUM_STRING);
	strcat (mount_cmd, "mount ");
	strcat (mount_cmd, dev);
	if (!(output = system(mount_cmd))){
		fprintf(stderr, "error launching %s in dockapp()\n", mount_cmd);
	}

	data[1] = dev;
	data[2] = command;
	data[3] = mountpoint;
	gtk_signal_connect (GTK_OBJECT(box), "button_press_event", GTK_SIGNAL_FUNC(callback), data);

	label = gtk_label_new(NULL);
	gtk_label_set_text( GTK_LABEL(label), model);
	gtk_label_set_justify (GTK_LABEL(label), GTK_JUSTIFY_CENTER);
	
	pixmap = (gpointer) gdk_pixmap_create_from_xpm (mainwin->window, &mask,
               	NULL, imagefile);
        pixmap_widget = gtk_pixmap_new((gpointer) pixmap, mask);
	
	
	
	gtk_container_add (GTK_CONTAINER (mainbox), table);
	gtk_table_attach_defaults(GTK_TABLE(table), labelbox, 0,4, 3,4);
	gtk_table_attach_defaults(GTK_TABLE(table), box, 0,4, 0,3);
	gtk_container_add (GTK_CONTAINER (box), pixmap_widget);
	gtk_container_add (GTK_CONTAINER (labelbox), label);
	
	gtk_widget_show(pixmap_widget);
	gtk_widget_show(label);
	gtk_widget_show(labelbox);
	gtk_widget_show(box);

	gtk_widget_show(table);	
	gtk_widget_show(mainbox);
	gtk_widget_show(mainwin);
	gtk_main ();
	gtk_widget_destroy (mainwin);		
	gtk_exit(EXIT_SUCCESS);
	exit(EXIT_SUCCESS);			
	return(EXIT_SUCCESS);
} // end 


// Function create_main_dockapp_icon_window (c) 2000, Alexey Vyskubov <alexey@pepper.spb.ru>

GtkWidget *create_main_dockapp_icon_window
		(GtkWidget *mw,
		unsigned int s,
		int margc,
		char *margv[])
{
	GtkWidget *dockappbox; // This will become icon box 
	Window xmw;
	XWMHints *wm_hints;
	
	xmw = GDK_WINDOW_XWINDOW(mw->window);
	
	dockappbox = gtk_event_box_new();
	gtk_widget_set_usize(dockappbox, s, s);
	gtk_container_add (GTK_CONTAINER (mw), dockappbox);
	gtk_widget_realize(dockappbox);
	
	// Time for game with Xlib 
	wm_hints = XAllocWMHints();
	wm_hints->window_group = xmw;
	wm_hints->icon_window = GDK_WINDOW_XWINDOW(dockappbox->window);
	wm_hints->icon_x = 0;
	wm_hints->icon_y = 0; 
	wm_hints->initial_state = WithdrawnState;
	wm_hints->flags = StateHint |
		IconPositionHint |
		WindowGroupHint |
		IconWindowHint;
	
	XSetWMHints(GDK_DISPLAY(), xmw, wm_hints);
	//XSetCommand(GDK_DISPLAY(), xmw, margv, margc);
	
	XFree(wm_hints);
	
	return dockappbox;
} // end create_main_dockapp_icon_window



// a function to launch command when button is clicked, and die ****************************
void callback
		(GtkWidget *event_box, 
		GdkEventButton *event,
		gpointer *data[])
{
	int output;
	char 
			*fm_cmd, 
			*umount_cmd;
	
	fm_cmd = malloc(MEDIUM_STRING);
	umount_cmd = malloc(MEDIUM_STRING);

	//fprintf(stderr, "data[1] = %s\n", (char *) data[1]);  //debug
	//fprintf(stderr, "data[2] = %s\n", (char *) data[2]);  //debug
	
	/* left button of mouse is clicked */
        if(event->button == 1)
        {
			memset(fm_cmd, 0, MEDIUM_STRING);
			strcat (fm_cmd, (char *) data[2]);
			strcat (fm_cmd, " ");
			strcat (fm_cmd, (char *) data[3]);
			strcat (fm_cmd, "/ &");
			//fprintf(stderr, "fm_cmd = %s\n", fm_cmd);  //debug
           	if (!(output = system(fm_cmd))){
				fprintf(stderr, "error launching %s in dockapp()\n", fm_cmd);
			}
			//fprintf(stderr, "left click \n"); // debug
           return;
        }

        /* right button of mouse is 2-clicked */
        if(event->button == 3)
        {
			if(event->type == GDK_2BUTTON_PRESS){
				memset(umount_cmd, 0, MEDIUM_STRING);
				strcat (umount_cmd, "umount ");
				strcat (umount_cmd, (char *) data[1]);
				//fprintf(stderr, "umount_cmd = %s\n", umount_cmd);  //debug
				if (!(output = system(umount_cmd))){
					fprintf(stderr, "error launching %s in dockapp()\n", umount_cmd);
				}
				memset(umount_cmd, 0, MEDIUM_STRING);
				strcat (umount_cmd, "eject ");
				strcat (umount_cmd, (char *) data[1]);
				//fprintf(stderr, "umount_cmd = %s\n", umount_cmd);  //debug
				if (!(output = system(umount_cmd))){
					fprintf(stderr, "error launching %s in dockapp()\n", umount_cmd);
				}
				//fprintf(stderr, "right click \n");
				gtk_main_quit();
			   return;
			}
        }

        /* both  buttons  of mouse is clicked // debug */
        if(event->button == 2)
        {
           //fprintf(stderr, "both buttons click \n"); // debug
           return;
        }
      
       /* double click of the mouse  */
        if(event->type == GDK_2BUTTON_PRESS)
        {
           //fprintf(stderr, "double click \n"); // debug
           return;
        }
	free(fm_cmd);
	free(umount_cmd);
	return;
} // end callback



// the function to parse the config file for parameters ****************************
int parse_from_config
		(u_int32_t 
		*uint_value, 
		char *char_value1, 
		char *char_value2, 
		char *filename, 
		char *param )
{
	int c;
	FILE *file;
	char 	*sep, 
		*buffer, 
		*line, 
		*value1,
		*value2;
	line = malloc(LONG_STRING); 
	buffer = malloc(MEDIUM_STRING); 
	sep = malloc(MEDIUM_STRING); 
	value1 = malloc(MEDIUM_STRING);
	value2 = malloc(MEDIUM_STRING);
	c = 0;	
	
	if((file=fopen(filename, "rb")) == 0) {
		fprintf (stderr,"Error opening file %s !\n",filename);
		exit(EXIT_FAILURE);
	}
	
	while (fgets (line, LONG_STRING, file) !=NULL) {
		if (strstr (line, "[") !=0) continue;
		if (strstr (line, "#") !=0) continue;
		memset(char_value1, 0, BIG_STRING);
		memset(char_value2, 0, BIG_STRING);
		c = sscanf (line, "%s %s %s %s", buffer, sep, value1, value2); 
		//fprintf(stderr, "%s\n", char_value); // debug
		if (strncmp (param, buffer, MEDIUM_STRING) == 0) {
			strncat(char_value1, value1, SHORT_STRING);
			strncat(char_value2, value2, SHORT_STRING);

			*uint_value = atoi(char_value1);
			fclose (file);
			return(EXIT_SUCCESS);
		}	
	}
	fclose (file);
	free(sep); 
	free(buffer);
	free(line);
	free(value1);
	free(value2);
	return(EXIT_FAILURE);
} // end parse_from_config

// the function to parse the config file for mount points ****************************
int parse_mountpoint
		(char *char_value, 
		char *filename, 
		char *param)
{
	int c;
	FILE *file;
	char 	*buffer, 
		*line, 
		*value,
		*nevermind;
	line = malloc(LONG_STRING); 
	nevermind = malloc(MEDIUM_STRING);
	buffer = malloc(MEDIUM_STRING); 
	value = malloc(MEDIUM_STRING);
	c = 0;	
	
	if((file=fopen(filename, "rb")) == 0) {
		fprintf (stderr,"Error opening file %s !\n",filename);
		exit(EXIT_FAILURE);
	}
	
	while (fgets (line, LONG_STRING, file) !=NULL) {
		if (strstr (line, "[") !=0) continue;
		if (strstr (line, "#") !=0) continue;
		memset(char_value, 0, BIG_STRING);
		c = sscanf (line, "%s %s %s", buffer, value, nevermind); 
		if (strncmp (param, buffer, MEDIUM_STRING) == 0) {
			strncat(char_value, value, SHORT_STRING);
			//fprintf(stderr, "mountpoint = %s\n", value); // debug
			fclose (file);
			return(EXIT_SUCCESS);
		}	
	}
	fclose (file);
	free(buffer);
	free(line);
	free(value);
	free(nevermind);
	return(EXIT_FAILURE);
} // end parse_mountpoint


// the function to get the CD model ****************************
int get_media
		(char *char_value, 
		char *procdev)
{
	int c;
	FILE *file;
	char 	*buffer, 
		*line, 
		*filename;
	line = malloc(LONG_STRING); 
	buffer = malloc(MEDIUM_STRING); 
	filename = malloc(MEDIUM_STRING);
	c = 0;	
	memset(filename, 0, MEDIUM_STRING);
	strncat(filename, procdev, 13);
	strcat(filename, "/media");
	// fprintf (stderr,"fiename= %s !\n",filename); // debug
	if((file=fopen(filename, "rb")) == 0) {
		fprintf (stderr,"Error opening file %s !\n",filename);
		exit(EXIT_FAILURE);
	}
	
	while (fgets (line, LONG_STRING, file) !=NULL) {
		memset(char_value, 0, BIG_STRING);
		c = sscanf (line, "%s", buffer); 
		if (strncmp ("", buffer, MEDIUM_STRING) != 0) {
			strncat(char_value, buffer, 11);
			//fprintf(stderr, "model = %s\n", buffer); // debug
			fclose (file);
			return(EXIT_SUCCESS);
		}	
	}
	fclose (file);
	free(buffer); 
	free(line);
	free(filename);
	return(EXIT_FAILURE);
} // end get_media
